import { search_flight, search_nominatim } from "../helper/api";
import { leg_template } from "./format";
import journey_wrapper from "./wrapper";


declare global {
    type query_type = "hotel" | "restaurant" | "place" | "flight"
    type note_type = "notes"
    type sub_type = "travel" | "other"

    interface query {
        type: query_type | note_type | "",
        sub: sub_type | "",
        query: string,
        res: any[],
        load: boolean,
        /* DELETE BELOW IF POSIBLE */
        addmarker: Boolean,
    }

    interface map_override {
        active: Boolean,
        elements: number[][]
    }
}

class search_drawer {
    map_override: map_override = { active: false, elements: [] };
    multipath : any[]=[];

    query: query = {
        type: "", query: "", sub: "", res: [], load: false, addmarker: false,
    }

    resfresh_map: () => void = () => { }
    get_bb: () => any[] = () => []
    get_leg: () => leg = () => leg_template

    constructor() {

    }

    show_drawer() {
        return this.is_note() || this.is_query()
    }

    is_note() {
        return ["notes"].includes(this.query.type)
    }
    is_place(){
        return ["hotel", "restaurant", "place"].includes(this.query.type)
    }
    is_query() {
        return this.is_place()|| this.is_flight() || this.is_multipath()
    }
    is_sub_travel() {
        return ["travel"].includes(this.query.sub)
    }
    is_multipath(){
        return ["flight", "train", "car","bike", "other"].includes(this.query.type)
    }
    is_flight(){
        return ["flight"].includes(this.query.type)
    }

    results(r: any[]) {
        this.query.load = false;
        this.query.res = r;
        return r
    }
    reset() {
        this.query.res = [];
        this.multipath = [];
        this.map_override.elements = []
        this.query.type = "";
        this.query.addmarker = false;
        setTimeout(() => this.resfresh_map(), 500);
    }

    active(tpe: query_type) {
        this.query.type = tpe;
        this.query.load = this.is_query();
        setTimeout(() => this.resfresh_map(), 500);
    }

    search(_e = null) {
        const tpe = this.query.type;
        const query = this.query.query;
        switch (tpe) {
            case 'flight':
                return search_flight(tpe, query, this.get_leg());
            default:
                return search_nominatim(tpe, query, this.get_bb(), this.get_leg())

        }
    }

    enable(f: query_type) {
        this.active(f)
        setTimeout(() => document.getElementById(this.is_note() ? 'query_note' : 'query_input')?.focus(), 500);
        if (this.is_query()) this.search()
    }

    hover_item (item?:any) {
      if (item) {
        this.map_override.active = true
        if (item.type == 'flight') {
          this.map_override.elements.push([item.from_geo.lat, item.from_geo.lon])
           this.map_override.elements.push([item.to_geo.lat, item.to_geo.lon])
        } else {
          this.map_override.elements.push([item.lat, item.lon])
        }
      } else {
        this.map_override.active = false
      }
    }

    click_item (journey: journey_wrapper, item?:any) {
      const tpe = this.query.type
      if(this.is_multipath()){
        if(this.query.addmarker){
            if(item){
                this.map_override.active = true
                this.map_override.elements.push(item.latlon? item.latlon: [item.lat,item.lon])
                this.multipath.push(item)
                return;
            }else{
                let new_item :geoloc = {
                    type: (tpe as string),
                    path: this.map_override.elements,
                    title: '-',
                    notes: "",
                }
                this.map_override.active = false
                journey.add_place(tpe, new_item)
            }
        }
      }
      this.reset();
      this.hover_item();
      if (item) {
        item.step = -1;
        journey.add_place(tpe, item)
      }
    }

}


export default search_drawer;